// RFiDJ.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>

using namespace std;
using namespace System;
using namespace System::IO::Ports;
using namespace System::Net;
using namespace System::Net::Sockets;

ref class g{
public:
	static System::IO::Ports::SerialPort^ port = gcnew SerialPort;
	static System::Net::Sockets::TcpClient^ sc = gcnew System::Net::Sockets::TcpClient();
	static System::Net::Sockets::NetworkStream^ stream;
    static System::Timers::Timer^ timer;	
	static int rfid_idx = 8;  // Init to unused rfid 
	static array<System::String ^>^ rfid = gcnew array<System::String ^>(9);
	static array<System::String ^>^ playlist = gcnew array<System::String ^>(9);
	static System::String^ stop = "d1:e5:c6:56:fc:7d stop\n"; 
};

void DataReceived(Object^ sender, System::IO::Ports::SerialDataReceivedEventArgs^ e)
{
	System::String ^str;
	System::String ^str_parsed;
	unsigned int str_len; 

	// Read tag id
	str = g::port->ReadLine(); 

	// Length of str
	str_len = str->Length; 

	// Can we find the start byte 0x0A?
	if ( (str_len > 12)  && (str[str_len-11] == 0x0A)  )
	{	
		// parse str startng with the start byte
		str_parsed = str->Substring(str_len - 11); 

		// Have we found a regstered rfid?
		for (int n=0; n<9; n++)
		{	
				if (!System::String::Compare(str_parsed, g::rfid[n]))
				{

					// Write every registered rfid detections to console
					//Console::WriteLine(g::rfid[n]);

					// is timer enabled? 
					if (g::timer->Enabled == false)
						g::timer->Start(); 
					else
					{
						// Reset timer
						g::timer->Stop(); 
						g::timer->Start(); 

						// Write status to console
						//Console::WriteLine("Time-out Reset");
					}

					// Do we have a new tag?
					if (g::rfid_idx != n)
					{
						// Write only new registered rfid detections to console
						//Console::WriteLine("New RFID detected");
						//Console::WriteLine(g::rfid[n]);
				
						// Set rfid index
						g::rfid_idx = n; 
				
						// Send command assigned to the rfid
						if (n != 3)
							System::Diagnostics::Process::Start("C:\\Program Files\\VideoLAN\\VLC\\vlc.exe", g::playlist[n]);
						else
							System::Diagnostics::Process::Start("curl.exe", "--basic --user logon:pass --data status=\"I am now using #RFiDJ Refresh.\" http://twitter.com/statuses/update.xml");
					}
																
					else
						break; 
				}
		}


	}

}

static void OnTimedEvent( Object^ source, System::Timers::ElapsedEventArgs^ e )
 {
	// Write debug status to console
	//Console::WriteLine("Tag Time-out"); 
	//Console::WriteLine("Media Stopped"); 

	// Stop any meda being played 		
	System::Diagnostics::Process::Start("C:\\Program Files\\VideoLAN\\VLC\\vlc.exe", "\\\\Guinness\\Volume_1\\Media\\Playlists\\400.m3u");

	// Reset rfid_idx
	g::rfid_idx = 8; 

	// Stop timer
	g::timer->Stop();  
 }

int _tmain(int argc, _TCHAR* argv[])
{
	// init rfid array
	g::rfid = gcnew array<System::String ^> {
		"\n23006EB49C",  // Jack Johnson
		"\n23006F3309",  // TWIS
		"\n23006F9903",  // Random
		"\n23006E91B5",  // Twitter Update
		"\n23006F83F0",  // TWIT.am
		"\n23006F7A05",  // WTOP		
		"\n23006F3D7B",  // KFI		
		"\n23006F396B",  // SOMAFM Groove Salad
		"\n0000000000"}; // RESERVED 

	// init playlist commands
	g::playlist = gcnew array<System::String ^> {
		"\\\\Guinness\\Volume_1\\Media\\Playlists\\100.m3u",															// 
		"\\\\Guinness\\Volume_1\\Media\\Playlists\\200.m3u",															// 
		"\\\\Guinness\\Volume_1\\Media\\Playlists\\300.m3u",															// 
		"curl -u logon:pass -d \"text=I am now using #RFiDJ Refresh&user=username \"http://twitter.com/direct_messages/new.xml",	// 
		"http://twit.am/listen.m3u",																					// 
		"http://opml.radiotime.com/Tune.ashx?id=s23234&partnerId=16",													// 
		"http://opml.radiotime.com/Tune.ashx?id=s32618&formats=aac,mp3,wma,wmpro,wmvoice,wmvideo,ogg&partnerId=16",		// 
		"http://205.188.215.227:8090",																					// 
		"\\\\Guinness\\Volume_1\\Media\\Playlists\\400.m3u"};															// Stop

	// configure port
	g::port->PortName	=	L"COM5";
	g::port->BaudRate	=	2400;
	g::port->DataBits	=	8;
	g::port->Parity		=	System::IO::Ports::Parity::None;
	g::port->StopBits	=	System::IO::Ports::StopBits::One;
	g::port->RtsEnable  =   true; 
	g::port->DtrEnable  =   true; 
	g::port->Handshake  =   System::IO::Ports::Handshake::None; 
	g::port->ReceivedBytesThreshold = 2; 
	g::port->NewLine = "\r";	// Use carriage return as delimiter for port.ReadLine()
	g::port->DataReceived += gcnew System::IO::Ports::SerialDataReceivedEventHandler(DataReceived);

	// Open serial port dedcated to RFID reader // TODO: Could use a timeout & exception if we cannot connect
	g::port->Open();

	// Write status to console
	//Console::WriteLine("RFID Reader Connected"); 
	      
	// Create a new timer 
	g::timer = gcnew System::Timers::Timer( );
    
	// Hook up the Elapsed event for the timer.
	g::timer->Elapsed += gcnew System::Timers::ElapsedEventHandler( OnTimedEvent );

	// Write status to console
	//Console::WriteLine("Timer Configured");

    // Set AutoReset to false & the interval 5 seconds (5000 milliseconds).
	g::timer->AutoReset = false;
	g::timer->Interval = 5000;

	// Loop
	while(1); 

	return 0;
}
